// C program to check a file is a directory or not

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#define TRUE 1
#define FALSE 0

/* test that dir exists (1 success, -1 does not exist, -2 not dir) */
int
xis_dir (const char *d)
{
    DIR *dirptr;

    if (access ( d, F_OK ) != -1 ) {
        // file exists
        if ((dirptr = opendir (d)) != NULL) {
            closedir (dirptr); /* d exists and is a directory */
        } else {
            return -2; /* d exists but is not a directory */
        }
    } else {
        return -1;     /* d does not exist */
    }

    return 1;
}


int isDir(const char* fileName)
{
    struct stat buff;

    stat(fileName, &buff);

    if( S_ISREG(buff.st_mode) == 0) return TRUE;
    else 
    return FALSE;
}

int isFile(const char* fileName)
{
struct stat buff;
        if(stat(fileName,&buff) == 0) return TRUE;
        else return FALSE;
}

int isafileTest(filename) char *filename; {
  FILE *fp=fopen(filename,"r"); 
  if(fp==NULL) return FALSE;
  fclose(fp);
  return TRUE;
}

int isadir(s) char *s; {
struct stat buf;

FILE *fp=fopen(s,"r");
if(fp==NULL) return FALSE;
fclose(fp);

    int x=stat(s, &buf);
    if( S_ISREG(buf.st_mode) != 0) return FALSE;
    if(x==0 && (buf.st_mode & S_IFDIR)!=0)
      return TRUE;

    return FALSE;

//  struct stat buf; // defined in header file sys/stat.h
//  if(stat(s,(struct stat *)&buf)==0 && (buf.st_mode & S_IFDIR)!=0)
//    return TRUE;
//  return FALSE;
}

int isafile(s) // return 1 if it is a file, 0 if not
char *s;
{ 
  if(isadir(s)==TRUE) return FALSE;
  if( access(s, F_OK) == -1 ) return FALSE;
  if(isafileTest(s)==TRUE) return TRUE; // can open the file 
  return FALSE;
 // access returns 0 if file exists, -1 on error
};

int main()
{
    char fileName[512];
    int ret = 0;

    printf("Enter filename: ");
    scanf("%s", fileName);

    ret = isDir(fileName);

    if (ret == TRUE)
        printf("isDir: File %s is a directory\n",fileName);
    else
        printf("isDir: File %s is not a directory\n",fileName);

    ret = isFile(fileName);

    if(ret==TRUE)
       printf("isFile: file %s exists.\n",fileName);
    else
        printf("isFile: file %s does not exist.\n",fileName);

FILE *fp=fopen(fileName,"r");
if(fp==0) 
printf("fopen failed on %s\n",fileName);
else {
printf("fopen worked on %s\n",fileName);
if(fp) fclose(fp);
}
 
    ret = isadir(fileName);

    if (ret == TRUE)
        printf("isadir: pathname %s is a folder in use and not a file\n",fileName);
    else
        printf("isadir:pathname %s is not a folder in use\n",fileName);

    ret = isafile(fileName);

    if(ret==TRUE)
       printf("isafile: pathname %s is a file in use and not a folder.\n",fileName);
    else
        printf("isafile: pathname %s is not a file in use.\n",fileName);

ret=xis_dir(fileName);
printf("xis_dir=%d\r\n",ret);
printf("1=success, -1=does not exist, -2=not a dir\r\n");

return 0;
} // end main()
